var Backbone = require('backbone')

Backbone.register = function(config) {
  Lilo.Model.urlRoot = config.urlRoot

  if (!Backbone.View.config) {
    Backbone.View.config = {}
  }

  if (!config.package) {
    config.package = {}
  }

  if (config.layoutPath) {
    Backbone.View.config.layoutPath = config.layoutPath
  }
  if (config.layoutViews) {
    Backbone.View.config.layoutViews = config.layoutViews
  }
  if (config.templatePath) {
    Backbone.View.config.templatePath = config.templatePath
  }
  if (config.layout) {
    Backbone.View.config.layout = config.layout
  }

  var package = Lilo.packager.createPackage({
    dependencies: config.package.deps,
    paths: config.package.paths
  }) 

  package.register({
    app: config.app,
    target: config.package.target
  })
  
  new Lilo.Router({ app: config.app, routes: config.routes })
}

Backbone.ajax = require('./lib/server/request')
Backbone.packager = require('./lib/server/packager')
Backbone.Router = require('./lib/server/router')
Backbone.View = require('./lib/server/view')

Lilo = module.exports = Backbone
